
#if !defined(_COMMON_H_)

    //#define LCD_SHIFT_REGISTER
    #define LCD_4BIT               // Your hardware setup

    #if defined(LCD_SHIFT_REGISTER)
        #define LCD_EN RC0
        #define LCD_DT RC1
        #define LCD_CK RC2
        #define LCD_EN_DIR TRISC0
        #define LCD_DT_DIR TRISC1
        #define LCD_CK_DIR TRISC2
    #else
        #define LCD_DIR_D7  TRISA6
        #define LCD_DIR_D6  TRISA7
        #define LCD_DIR_D5  TRISA0
        #define LCD_DIR_D4  TRISA1
        #define LCD_DIR_RS  TRISA2
        #define LCD_DIR_EN  TRISA3
        #define LCD_D7      RA6
        #define LCD_D6      RA7
        #define LCD_D5      RA0
        #define LCD_D4      RA1
        #define LCD_RS      RA2
        #define LCD_EN      RA3
    #endif

    #define LCD_LINE1 0x80
    #define LCD_LINE2 0xC0
    #define LCD_CLEAR 0x01
    #define LCD_HOME  0x02
    
    #define LCD_CURSOR_ON    0x0E
    #define LCD_CURSOR_OFF   0x0C
    #define LCD_CURSOR_BLINK 0x0F

// For hd44870 controller compatible series LCD_CMDCHAR can be any in range 0xE8 - 0xFF;
// For EA DIP series (ks0073 controller) LCD_CMDCHAR can be any in range 0xF4 - 0xFF;
// For EA DOG-M series (st7036 controller) LCD_CMDCHAR can be any in range 0xE8 - 0xFF;
// Those numbers can represent "Set DRAM Address" instruction, but these
// adrress does not exist so there will be no conflict.

    #define LCD_CMDCHAR 0xF4
    //#define SECOND_TASK_CMDCHAR 0xF5
    
    #warning "File lcd.h included directly. Use common.h instead."
#endif

#define lcdCmd(x) {lcdPutch(LCD_CMDCHAR);lcdPutch(x);}

void lcdInit(void);
void lcdPutch(unsigned char);
void lcdPuts(unsigned char, const unsigned char *);
//void lcdWellcomeScreen(void);
